#include <iostream>
using namespace std;

int d[100000];
int f[100000];
int g[100000];
int h[100000];

int main() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) 
    {
        cin >> d[i] >> f[i];
    }
    for (int i = 0; i < q; i++) 
    {
        cin >> g[i];
    }
    h[0] = f[0];
    for (int i = 1; i < n; i++) 
    {
        h[i] = h[i - 1] + f[i];
    }
    int kupljen = 0;
    int poj = 0;
    int ima = 0;
    int pd = 0;
    for (int i = 0; i < q; i++) 
    {
        int k = g[i];
        while (pd < k) 
        {
            pd++;
            while (kupljen < n && d[kupljen] == pd)
            {
                ima += f[kupljen];
                kupljen++;
            }
            if (ima > 0) 
            {
                poj++;
                ima--;
            }
        }
        cout << poj << endl;
    }

    return 0;
}